<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Transform - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="AdjustableTransform.html">AdjustableTransform</a><ul class='members'><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#costs">costs</a></li><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#upsilons">upsilons</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isConnected">isConnected</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isDependent">isDependent</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getB">getB</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getBValues">getBValues</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjust">adjust</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjustWeights">adjustWeights</a></li></ul></li><li><a href="BufferedOutputWeightAdjustment.html">BufferedOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="EntropyWeightAdjustment.html">EntropyWeightAdjustment</a><ul class='members'></ul></li><li><a href="LpOutputWeightAdjustment.html">LpOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="NLNTransform.html">NLNTransform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NLNTransform.html#createConnection">createConnection</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#h">h</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#dh">dh</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#g">g</a></li></ul></li><li><a href="OutputWeightAdjustment.html">OutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="OutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="QuadLin.html">QuadLin</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QuadLin.html#setWo">setWo</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#f">f</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#df">df</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#dw">dw</a></li></ul></li><li><a href="QuadLinOutputWeightAdjustment.html">QuadLinOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="QuadLinWeightRegularization.html">QuadLinWeightRegularization</a><ul class='members'></ul></li><li><a href="RandomOutputWeightAdjustment.html">RandomOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="RandomOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="RandomTransformInput.html">RandomTransformInput</a><ul class='members'></ul></li><li><a href="ReservoirTransform.html">ReservoirTransform</a><ul class='members'></ul></li><li><a href="Sigmoid.html">Sigmoid</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Sigmoid.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Sigmoid.html#df">df</a></li></ul></li><li><a href="Transform.html">Transform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Transform.html#init">init</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getParameter">getParameter</a></li><li data-type='method' style='display: none;'><a href="Transform.html#asString">asString</a></li><li data-type='method' style='display: none;'><a href="Transform.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getF">getF</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getFValues">getFValues</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeights">getWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setW">setW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeightsDistance">getWeightsDistance</a></li></ul></li><li><a href="TransformBuffer.html">TransformBuffer</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformBuffer.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#load">load</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#get">get</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitCount">getUnitCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeCount">getTimeCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitSlice">getUnitSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeSlice">getTimeSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getSamples">getSamples</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getChannels">getChannels</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#asString">asString</a></li></ul></li><li><a href="TransformInput.html">TransformInput</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformInput.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="TransformInput.html#i">i</a></li></ul></li><li><a href="TransformObserver.html">TransformObserver</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformObserver.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStats">getStats</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#plotData">plotData</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#simulate">simulate</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getSpatialDivergence">getSpatialDivergence</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#asString">asString</a></li></ul></li><li><a href="WeightAdjustment.html">WeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#c">c</a></li><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#dc">dc</a></li></ul></li><li><a href="WeightRegularization.html">WeightRegularization</a><ul class='members'><li data-type='member' style='display: none;'><a href="WeightRegularization.html#.upsilon">upsilon</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightRegularization.html#l">l</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Transform</h1>
    

    




<section>

<header>
    
        <h2>
        
            Transform
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Transform"><span class="type-signature"></span>new Transform<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Defines a general discrete time parameterized dynamical system.</p>
<ul>
<li>The <code>f(·)</code> method has to be implemented, as made explicit in the <a href="./derivaion.pdf">equation summary</a>`.</li>
<li>The forward state values are calculated, updated if needed and buffered for <code>0 &lt;= n &lt; N</code> and <code>0 &lt;= t &lt; T</code>.</li>
<li>The parameters (or weights) are buffered at this level.</li>
<li>By contract, connectivity is fixed and initializes in the constructor, variable connectivity is implemented via <code>0</code> value weights.</li>
<li>By contract, weights are initialized in the constructor, their default value is <code>0</code>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>Object parameter:</p>
<ul>
<li><code>N</code> Number of state units.</li>
<li><code>T</code> Time window step count.</li>
<li><code>K</code> Number of parameters.</li>
<li><code>Wstdev [= 0]</code> Weights normal random initial value standard-deviation, using <a href="#setWeights">setWeights</a>.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>














<h5 class="h5-throws">Throws:</h5>

        

    <div class="param-desc usertext">
    
        <p>illegal-argument exception if some parameter is ill-defined.</p>
    
    </div>


    





        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="init"><span class="type-signature type-signature-abstract, protected">(abstract, protected) </span>init<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Called at the beginning of the object construction to allow a programmatic determination of the parameters.</p>
<ul>
<li>This virtual routine can be overwritten by subclasses to set the transform architecture, such as connections,</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>The in/out parameters values.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="getParameter"><span class="type-signature"></span>getParameter<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the object parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="asString"><span class="type-signature"></span>asString<span class="signature">()</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns object parameters as a parsable weak json string.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The string.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="f"><span class="type-signature type-signature-abstract">(abstract) </span>f<span class="signature">(n, t)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the dynamic equation.</p>
<ul>
<li>By contract, out of bounds values are set to 0.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>t</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getF"><span class="type-signature"></span>getF<span class="signature">(n, t)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the current forward value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>t</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value, or <code>0</code> if out of bound.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getFValues"><span class="type-signature"></span>getFValues<span class="signature">()</span><span class="type-signature"> &rarr; {Array}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the current forward values.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A 1D <code>double[N * T]</code> array with <code>x_n(t) = forward_values[n + N * t]</code>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getW"><span class="type-signature"></span>getW<span class="signature">(k)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the current parameter value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Parameter index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value, or <code>NAN</code> if out of bound.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getWeights"><span class="type-signature"></span>getWeights<span class="signature">()</span><span class="type-signature"> &rarr; {Array}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the weight values</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A <code>double[K]</code> array with the weight values.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="setW"><span class="type-signature"></span>setW<span class="signature">(k, w)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Sets the current parameter value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Parameter index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>w</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The corresponding value.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="setWeights"><span class="type-signature"></span>setWeights<span class="signature">(Wstdev<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Randomly initializes the current parameter's values.</p>
<ul>
<li>Draws a normal distribution of zero mean and a given standard-deviation</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>Wstdev</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The standard-deviation, by default use <code>stdev = 1/K</code></p>
<ul>
<li>If <code>&gt; 0</code>, weights are down a normal distribution of zero mean and a <code>Wstdev</code> standard-deviation.</li>
<li>If <code>-1</code>, uses the Xavier initialization value: <code>Wstdev = 1/N^(1/2)</code>.</li>
<li>If <code>-2</code>, uses the Brian initialization value: <code>Wstdev = 1/K</code>.</li>
<li>If <code>0</code> or any other negative value, weights are set to 0.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="setWeights"><span class="type-signature"></span>setWeights<span class="signature">(source)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Initializes the current parameter's values from another transform or array.</p>
<ul>
<li>By contract the source transform must have compatible structure and number of parameters, otherwise:</li>
<li>If the source are more parameters, only the <code>K</code> 1st weights are considered.</li>
<li>If the source are less parameters, only these parameters are considered as the 1st parameters.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Transform.html">Transform</a></span>
|

<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>The source transform.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="getWeightsDistance"><span class="type-signature"></span>getWeightsDistance<span class="signature">(source, norm<span class="signature-attributes">opt</span>, relative<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the distance between this weight vector and another source weight vector.</p>
<ul>
<li>By contract the source system must have compatible structure and number of parameters.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Transform.html">Transform</a></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The source transform.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>norm</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>'2'</code>
                
                </td>
            

            <td class="description last"><p>The chosen norm:</p>
<ul>
<li>'0' : The max norm.</li>
<li>'1' : The L1 norm.</li>
<li>'2' : The L2 norm.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>relative</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>If true calculates the relative distance : <code>||this - source|| / ||source||</code>.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>